	TITLE	  DATETIME - SET DATE AND TIME TO NEWEST FILE
	PAGE	,132
;
; DATETIME.COM TO set the date and time
;
;Original program from REMark, May 1983, Issue 40
;
;COPYRIGHT MAR 20,1983 BY Frank T. Clark, page 31, May 1983, REMark
;
;This program is designed to run from an AUTOEXEC.BAT file. It
;will automatically scan the entire directory selecting the date
;from the newest file. If this is more recent than the current date
;it will set the date and time. In any event, it will create a file
;DATETIME.TMP which of course will have the date and time just set.
;This program can also be run at any time without any deletorious
;effects. An argument can be given specifying the drive to be searched
;and written to.
;
;Suggested AUTOEXEC.BAT file contents:
;
;DATETIME A:
;DATETIME B:
;
	.xlist
	include defms.asm
	.list
pgmseg	segment
	assume	cs:pgmseg,ss:pgmseg,ds:pgmseg,es:nothing
	org	0100h
;
;start with ????????.??? and search for first directory entry
;
start:
	cld
	mov	di,phd_fcb1+1
	mov	cx,11
	mov	al,'?'
	rep stosb
	mov	dx,phd_fcb1
	mov	ah,dosf_srhfi
	int	dosi_func
;
;get the date and time from this and successive files
;
loop:
	mov	dx,ds:[phd_dioa+25]	;fetch date bits
	mov	di,offset buffer
	mov	cl,7
	rol	dx,cl
	mov	ax,dx
	and	ax,01111111b
	add	ax,1980
	xchg	al,ah
	stosw
	mov	cl,4
	rol	dx,cl
	mov	ax,dx
	and	ax,01111b
	stosb
	mov	cl,5
	rol	dx,cl
	mov	ax,dx
	and	ax,011111b
	stosb
	mov	dx,ds:[phd_dioa+23]	;fetch time bits
	mov	cl,5
	rol	dx,cl
	mov	ax,dx
	and	ax,011111b
	stosb
	mov	cl,6
	rol	dx,cl
	mov	ax,dx
	and	ax,0111111b
	stosb
	mov	si,offset buffer2
	mov	di,offset buffer
	mov	cx,6
	repe cmpsb
	jae	older
;
;remember the date of this most recent file
;
	mov	si,offset buffer
	mov	di,offset buffer2
	mov	cx,6
	rep movsb
;
;ignore old file and search for the next
;
older:
	mov	dx,phd_fcb1
	mov	ah,dosf_srhnx		;search the rest
	int	dosi_func
	cmp	al,0ffh
	jne	loop
;
;is the current date greater?
;
	mov	ah,dosf_gdate
	int	dosi_func
	xchg	ch,cl
	mov	word ptr buffer,cx
	xchg	dh,dl
	mov	word ptr buffer+2,dx
	mov	ah,dosf_gtime
	int	dosi_func
	xchg	ch,cl
	mov	word ptr buffer+4,cx
	mov	si,offset buffer2
	mov	di,offset buffer
	mov	cx,6
	repe cmpsb
	jbe	check
;
;set to the new date
;
	mov	cx,word ptr buffer2
	xchg	ch,cl
	mov	dx,word ptr buffer2+2
	xchg	dh,dl
	mov	ah,dosf_sdate
	int	dosi_func
	mov	cx,word ptr buffer2+4
	xchg	ch,cl
	mov	dx,word ptr buffer2+6
	mov	ah,dosf_stime
	int	dosi_func
;
;check for any other modifications?
;
check:
;create file datetime.tmp with current time
	mov	si,offset filename
	mov	di,phd_fcb1+1
	mov	cx,11
	rep movsb
	mov	dx,phd_fcb1
	mov	ah,dosf_crfile
	int	dosi_func
	mov	dx,phd_fcb1
	mov	ah,dosf_clfile
	int	dosi_func
stop:
	int	dosi_term
buffer	db	6 dup(0)
buffer2 db	6 dup(0)
	db	99,59	;jump to next minute immediately
filename db	'datetimetmp'
pgmseg	ends
	end	start
;--------------------------------------------------------------------------
;
;The following commands will create the DATETIME program
;after is has been entered into the file DATETIME.ASM
;using EDLIN.
;	MASM	DATETIME;
;	LINK	DATETIME;
;	ERASE	DATETIME.OBJ;
;	EXE2BIN DATETIME.EXE.COM
;	ERASE	DATETIME.EXE
M
;using EDLIN.
;	MASM	DATETIME;